]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
Add support for "preswitch" scripts
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devices
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by default, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 XDPYINFO=/usr/bin/xdpyinfo
50 PROFILES=~/.autorandr/
51 CONFIG=~/.autorandr.conf
52
53 CHANGE_PROFILE=0
54 FORCE_LOAD=0
55 DEFAULT_PROFILE=""
56 SAVE_PROFILE=""
57
58 FP_METHODS="setup_fp_xrandr_edid setup_fp_sysfs_edid"
59 CURRENT_CFG_METHOD="current_cfg_xrandr"
60 LOAD_METHOD="load_cfg_xrandr"
61
62 SCRIPTNAME="$(basename $0)"
63 # when called as autodisper/auto-disper, we assume different defaults
64 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
65         echo "Assuming disper defaults..." >&2
66         FP_METHODS="setup_fp_disper"
67         CURRENT_CFG_METHOD="current_cfg_disper"
68         LOAD_METHOD="load_cfg_disper"
69 fi
70
71 if [ -f $CONFIG ]; then
72         echo "Loading configuration from '$CONFIG'" >&2
73         . $CONFIG
74 fi
75
76 setup_fp_xrandr_edid() {
77         $XRANDR -q --verbose | awk '
78         /^[^ ]+ (dis)?connected / { DEV=$1; }
79         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
80         END { for (X in ID) { print X " " ID[X]; } }'
81 }
82
83 setup_fp_sysfs_edid() {
84         # xrandr triggers the reloading of EDID data
85         $XRANDR -q > /dev/null
86         # hash the EDIDs of all _connected_ devices
87         for P in /sys/class/drm/card*-*/; do
88                 # nothing found
89                 [ ! -d "$P" ] && continue
90                 if grep -q "^connected$" < "${P}status"; then
91                         echo -n "$(basename "$P") "
92                         md5sum ${P}edid | awk '{print $1}'
93                 fi
94         done
95 }
96
97 setup_fp_disper() {
98         $DISPER -l | grep '^display '
99 }
100
101 setup_fp() {
102         local FP="";
103         for M in $FP_METHODS; do
104                 FP="$($M)"
105                 if [ -n "$FP" ]; then
106                         break
107                 fi
108         done
109         if [ -z "$FP" ]; then
110                 echo "Unable to fingerprint display configuration" >&2
111                 return
112         fi
113         echo "$FP"
114 }
115
116 current_cfg_xrandr() {
117         local PRIMARY_SETUP="";
118         if [ -x "$XDPYINFO" ]; then
119                 PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
120         fi
121         $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
122         # display is connected and has a mode
123         /^[^ ]+ connected [^(]/ {
124                 split($3, A, "+");
125                 print "output "$1;
126                 print "mode "A[1];
127                 print "pos "A[2]"x"A[3];
128                 if ($4 !~ /^\(/) {
129                         print "rotate "$4;
130                 }
131                 if (A[1] A[2] "," A[3] == primary_setup)
132                         print "primary";
133                 next;
134         }
135         # disconnected or disabled displays
136         /^[^ ]+ (dis)?connected / ||
137         /^[^ ]+ unknown connection / {
138                 print "output "$1;
139                 print "off";
140                 next;
141         }'
142 }
143
144 current_cfg_disper() {
145         $DISPER -p
146 }
147
148 current_cfg() {
149         $CURRENT_CFG_METHOD;
150 }
151
152 blocked() {
153         local PROFILE="$1"
154         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
155
156         "$PROFILES/$PROFILE/block" "$PROFILE"
157 }
158
159 config_equal() {
160         local PROFILE="$1"
161         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
162                 echo "Config already loaded"
163                 return 0
164         else
165                 return 1
166         fi
167 }
168
169 load_cfg_xrandr() {
170         sed 's!^!--!' "$1" | xargs $XRANDR
171 }
172
173 load_cfg_disper() {
174         $DISPER -i < "$1"
175 }
176
177 load() {
178         local PROFILE="$1"
179         local CONF="$PROFILES/$PROFILE/config"
180         if [ -e "$CONF" ] ; then
181     [ -x "$PROFILES/preswitch" ] && \
182       "$PROFILES/preswitch" "$PROFILE"
183     [ -x "$PROFILES/$PROFILE/preswitch" ] && \
184       "$PROFILES/$PROFILE/preswitch" "$PROFILE"
185
186                 echo " -> loading profile $PROFILE"
187                 $LOAD_METHOD "$CONF"
188
189                 [ -x "$PROFILES/$PROFILE/postswitch" ] && \
190                         "$PROFILES/$PROFILE/postswitch" "$PROFILE"
191                 [ -x "$PROFILES/postswitch" ] && \
192                         "$PROFILES/postswitch" "$PROFILE"
193         fi
194 }
195
196 help() {
197         cat <<EOH
198 Usage: $SCRIPTNAME [options]
199
200 -h, --help              get this small help
201 -c, --change            reload current setup
202 -s, --save <profile>    save your current setup to profile <profile>
203 -l, --load <profile>    load profile <profile>
204 -d, --default <profile> make profile <profile> the default profile 
205 --force                 force (re)loading of a profile
206 --fingerprint           fingerprint your current hardware setup
207 --config                dump your current xrandr setup
208
209  To prevent a profile from being loaded, place a script call "block" in its
210  directory. The script is evaluated before the screen setup is inspected, and
211  in case of it returning a value of 0 the profile is skipped. This can be used
212  to query the status of a docking station you are about to leave.
213
214  If no suitable profile can be identified, the current configuration is kept.
215  To change this behaviour and switch to a fallback configuration, specify
216  --default <profile>.
217
218  Another script called "postswitch "can be placed in the directory
219  ~/.autorandr as well as in any profile directories: The scripts are executed
220  after a mode switch has taken place and can notify window managers.
221
222  When called by the name "autodisper" or "auto-disper", the script uses "disper"
223  instead of "xrandr" to detect, configure and save the display configuration.
224
225 EOH
226         exit
227 }
228 # process parameters
229 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,config,help -- "$@")
230 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
231 eval set -- "$OPTS"
232
233 while true; do
234         case "$1" in
235                 -c|--change) CHANGE_PROFILE=1; shift ;;
236                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
237                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
238                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
239                 -h|--help) help ;; 
240                 --force) FORCE_LOAD=1; shift ;;
241                 --fingerprint) setup_fp; exit 0;;
242                 --config) current_cfg; exit 0;;
243                 --) shift; break ;;
244                 *) echo "Error: $1"; exit 1;;
245         esac
246 done
247
248 CURRENT_SETUP="$(setup_fp)"
249
250 if [ -n "$SAVE_PROFILE" ]; then
251         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
252         mkdir -p "$PROFILES/$SAVE_PROFILE"
253         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
254         $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
255         exit 0
256 fi
257
258 if [ -n "$LOAD_PROFILE" ]; then
259         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
260         exit $?
261 fi
262
263 for SETUP_FILE in $PROFILES/*/setup; do
264         if ! [ -e $SETUP_FILE ]; then
265                 break
266         fi
267         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
268         echo -n "$PROFILE"
269
270         if blocked "$PROFILE"; then
271                 echo " (blocked)"
272                 continue
273         fi
274
275         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
276         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
277                 echo " (detected)"
278                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
279                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
280                                 load "$PROFILE"
281                         fi
282                 fi
283                 # found the profile, exit with success
284                 exit 0
285         else
286                 echo ""
287         fi
288 done
289
290 # we did not find the profile, load default
291 if [ -n "$DEFAULT_PROFILE" ]; then
292         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
293         load "$DEFAULT_PROFILE"
294 fi
295 exit 1